# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TerraformToBlueprintMapping(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'compatible_versions': 'list[str]',
        'variables': 'list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingVariables]',
        'output_values': 'list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingOutputValues]',
        'providers': 'list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingProviders]',
        'configuration_source_reference': 'BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingConfigurationSourceReference',
        'warnings': 'list[str]'
    }

    attribute_map = {
        'compatible_versions': 'compatibleVersions',
        'variables': 'variables',
        'output_values': 'outputValues',
        'providers': 'providers',
        'configuration_source_reference': 'configurationSourceReference',
        'warnings': 'warnings'
    }

    def __init__(self, compatible_versions=None, variables=None, output_values=None, providers=None, configuration_source_reference=None, warnings=None):  # noqa: E501
        """TerraformToBlueprintMapping - a model defined in Swagger"""  # noqa: E501
        self._compatible_versions = None
        self._variables = None
        self._output_values = None
        self._providers = None
        self._configuration_source_reference = None
        self._warnings = None
        self.discriminator = None
        if compatible_versions is not None:
            self.compatible_versions = compatible_versions
        if variables is not None:
            self.variables = variables
        if output_values is not None:
            self.output_values = output_values
        if providers is not None:
            self.providers = providers
        if configuration_source_reference is not None:
            self.configuration_source_reference = configuration_source_reference
        if warnings is not None:
            self.warnings = warnings

    @property
    def compatible_versions(self):
        """Gets the compatible_versions of this TerraformToBlueprintMapping.  # noqa: E501

        Compatible versions of Terraform that can be used to execute this configuration.  # noqa: E501

        :return: The compatible_versions of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: list[str]
        """
        return self._compatible_versions

    @compatible_versions.setter
    def compatible_versions(self, compatible_versions):
        """Sets the compatible_versions of this TerraformToBlueprintMapping.

        Compatible versions of Terraform that can be used to execute this configuration.  # noqa: E501

        :param compatible_versions: The compatible_versions of this TerraformToBlueprintMapping.  # noqa: E501
        :type: list[str]
        """

        self._compatible_versions = compatible_versions

    @property
    def variables(self):
        """Gets the variables of this TerraformToBlueprintMapping.  # noqa: E501

        Information about variables expected by the Terraform configuration.  # noqa: E501

        :return: The variables of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingVariables]
        """
        return self._variables

    @variables.setter
    def variables(self, variables):
        """Sets the variables of this TerraformToBlueprintMapping.

        Information about variables expected by the Terraform configuration.  # noqa: E501

        :param variables: The variables of this TerraformToBlueprintMapping.  # noqa: E501
        :type: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingVariables]
        """

        self._variables = variables

    @property
    def output_values(self):
        """Gets the output_values of this TerraformToBlueprintMapping.  # noqa: E501

        Information about output values generated by the Terraform configuration.  # noqa: E501

        :return: The output_values of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingOutputValues]
        """
        return self._output_values

    @output_values.setter
    def output_values(self, output_values):
        """Sets the output_values of this TerraformToBlueprintMapping.

        Information about output values generated by the Terraform configuration.  # noqa: E501

        :param output_values: The output_values of this TerraformToBlueprintMapping.  # noqa: E501
        :type: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingOutputValues]
        """

        self._output_values = output_values

    @property
    def providers(self):
        """Gets the providers of this TerraformToBlueprintMapping.  # noqa: E501

        Information about providers used in the Terraform configuration.  # noqa: E501

        :return: The providers of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingProviders]
        """
        return self._providers

    @providers.setter
    def providers(self, providers):
        """Sets the providers of this TerraformToBlueprintMapping.

        Information about providers used in the Terraform configuration.  # noqa: E501

        :param providers: The providers of this TerraformToBlueprintMapping.  # noqa: E501
        :type: list[BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingProviders]
        """

        self._providers = providers

    @property
    def configuration_source_reference(self):
        """Gets the configuration_source_reference of this TerraformToBlueprintMapping.  # noqa: E501


        :return: The configuration_source_reference of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingConfigurationSourceReference
        """
        return self._configuration_source_reference

    @configuration_source_reference.setter
    def configuration_source_reference(self, configuration_source_reference):
        """Sets the configuration_source_reference of this TerraformToBlueprintMapping.


        :param configuration_source_reference: The configuration_source_reference of this TerraformToBlueprintMapping.  # noqa: E501
        :type: BlueprintapiblueprintintegrationsterraformcreateblueprintfrommappingTerraformToBlueprintMappingConfigurationSourceReference
        """

        self._configuration_source_reference = configuration_source_reference

    @property
    def warnings(self):
        """Gets the warnings of this TerraformToBlueprintMapping.  # noqa: E501

        A list of warnings related to the Terraform configuration.  # noqa: E501

        :return: The warnings of this TerraformToBlueprintMapping.  # noqa: E501
        :rtype: list[str]
        """
        return self._warnings

    @warnings.setter
    def warnings(self, warnings):
        """Sets the warnings of this TerraformToBlueprintMapping.

        A list of warnings related to the Terraform configuration.  # noqa: E501

        :param warnings: The warnings of this TerraformToBlueprintMapping.  # noqa: E501
        :type: list[str]
        """

        self._warnings = warnings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TerraformToBlueprintMapping, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TerraformToBlueprintMapping):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
